Subject: Re: bug#35660: guix weather runaway memory consumption

From: swedebugia <[email-masked]>
Date: Wed, 15 May 2019 13:53:54 +0200

On 2019-05-14 22:52, Ludovic Courtès wrote:
> Hi Danny,
> 
> Danny Milosavljevic <[email-masked]> skribis:
> 
>> The failure mode here is very very bad.  Guix will consume all available
>> memory and then start on the swap, at which point the computer will
>> become unresponsive to any input and the user can't save any open
>> documents and has to kill the power to the computer.
> 
> I agree that the failure mode is terrible.  It’s very likely a cycle in
> the package graph, given the symptoms you describe.  So ‘guix build
> OFFENDING-PACKAGE’ would probably give you the same result.
> 
> Chris Baines proposed a patch a while back to detect and report cycles,
> but we never got around to polishing and integrating it.  That would
> probably help a lot in these cases.
> 
> We can open a new bug for that (if there’s not already one), but I think
> it should be framed in terms of cycle detection in the package graph and
> error reporting.

+1

When working on the NPM importer earlier this was very very common 
happening with "guix build NPM-PACKAGE" because of cycles.

My strategy was to manually kill the build after a minute or two if no 
output was produced.

-- 
Cheers Swedebugia